



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>UVALive - 3942：Remember the Word</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">UVALive - 3942：Remember the Word</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-21 21:37:39 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>发现字典里面的单词数目多且长度短，可以用字典树保存</p>
<p>f[i]表示s[i~L]的分割方式，则有f[i]=&sum;f[i+len(word[j])]&nbsp;&nbsp; 其中word[j]为s[i~L]的前缀</p>
<p>注意字典树又叫前缀树，所以用前缀更方便，否则按顺序dp的话就要把字符倒序了</p>
<p>复杂度O(L*l) L为字符串长度，l为单词长度</p>
<div>
<pre class="prettyprint linenums">#include&lt;cstdio&gt;<br />
#include&lt;cstdlib&gt;<br />
#include&lt;algorithm&gt;<br />
#include&lt;cstring&gt;<br />
#define MAXN 300005<br />
#define MOD 20071027<br />
using namespace std;<br />
struct Trie{<br />
    Trie* nxt[];<br />
    int v;<br />
    Trie(){<br />
        for(int i=;i&lt;;i++){<br />
            nxt[i]=NULL;<br />
        }<br />
        v=;<br />
    }<br />
};<br />
Trie *root;<br />
void insert(char s[],int vl){<br />
    Trie *p=root;<br />
    int len=strlen(s);<br />
    for(int i=;i&lt;len;i++){<br />
        int t=s[i]-;<br />
        if(p-&gt;nxt[t]){<br />
            p=p-&gt;nxt[t];<br />
        }<br />
        else{<br />
            p-&gt;nxt[t]=new Trie;<br />
            p=p-&gt;nxt[t];<br />
        }<br />
    }<br />
    p-&gt;v=vl;<br />
}<br />
int f[MAXN];<br />
char s[MAXN];<br />
int n,L;<br />
int find(int st){<br />
    int ret=;<br />
    Trie *p=root;<br />
    for(int i=st;i&lt;L;i++){<br />
        int t=s[i]-;<br />
        if(p-&gt;nxt[t]){<br />
            p=p-&gt;nxt[t];<br />
            if(p-&gt;v){<br />
                (ret+=f[i+])%=MOD;<br />
            }<br />
        }<br />
        else{<br />
            return ret;<br />
        }<br />
    }<br />
    return ret;<br />
}<br />
void del(Trie *p){<br />
    if(p){<br />
        for(int i=;i&lt;;i++){<br />
            if(p-&gt;nxt[i]){<br />
                del(p-&gt;nxt[i]);<br />
            }<br />
        }<br />
        delete p;<br />
    }<br />
}<br />
int main()<br />
{<br />
    int T=;<br />
    while(~scanf("%s",s)){<br />
        memset(f,,sizeof(f));<br />
        del(root);<br />
        L=strlen(s);<br />
        root=new Trie;<br />
        scanf("%d",&amp;n);<br />
        for(int i=;i&lt;=n;i++){<br />
            char ch[]={};<br />
            scanf("%s",ch);<br />
            insert(ch,);<br />
        }<br />
        f[L]=;<br />
        for(int i=L-;i&gt;=;i--){<br />
            f[i]=find(i);<br />
        }<br />
        printf("Case %d: %d\n",++T,f[]);<br />
    }<br />
    return ;<br />
}</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m8z3ow3q.html">C&sol;C&plus;&plus;二维数组分配内存</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qy3g3d8.html">Linux内核设计第八周 &mdash;&mdash;进程的切换和系统的一般执行过程</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnzlxxq.html">Android ContentResolve使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gwj3e8.html">T4模板TextTemplatingFileGenerator和TextTemplatingFilePreprocessor区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/qde5znx9.html">POJ 2653 Pick-up sticks（线段相交）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yw4k3q.html">udelay、mdelay、ndelay、msleep使用比较说明</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn104nj8.html">&lbrack;原&rsqb;H264帧内预测</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm64pk9.html">Hibernate&lpar;四&rpar;&mdash;&mdash;缓存策略&plus;lazy</a>
		</li>
						<li><a href="https://www.batexi.com/a/96o63139.html">高效的SQLSERVER分页查询&lpar;推荐&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pd3v2z9.html">Linux下关闭JBoss实例</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25kdnvq.html">详解margin： auto</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyy00ddq.html">20172306 2018-2019《Java程序设计与数据结构课堂测试补充报告》</a>
		</li>
						<li><a href="https://www.batexi.com/a/960kpdy9.html">theano使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/9602lg39.html">探讨后端选型中不同语言及对应的Web框架</a>
		</li>
						<li><a href="https://www.batexi.com/a/902n0knq.html">PO&lowbar;全局一揽子采购协议（流程）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jm65xw9.html">poj&lowbar;1390 动态规划</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyv36zdq.html">Kernel space是啥？</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mj4xr28.html">JS地址自动返填技术</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql162009.html">第二章：Internet地址结构</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4pr3d3q.html">搭建自己的PHP框架心得&mdash;&mdash;转载</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qv1prx1q.html">Linux下I&sol;O多路转接之epoll&lpar;绝对经典&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/950lzp68.html">SOAP不同版本引起的问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/9ge6rx78.html">style scoped</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojpl01q.html">总体来说，require&lowbar;once 肯定要比 require 性能好</a>
			</li>
						<li><a href="https://www.batexi.com/a/9ge6xjz8.html">ll的命令后面的字段详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwjpxdl8.html">算法题丨3Sum Closest</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1nxgxq.html">Python内置函数&lpar;19&rpar;&mdash;&mdash;oct</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ey62pj9.html">emqtt 试用（二）验证 emq 和 mosquito 的共享订阅</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnj6kn38.html">操作MP3文件的元数据</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rgp36e8.html">ELK学习总结（3-1）elk的基本查询</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
